#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <time.h>

#ifndef O_BINARY
#define O_BINARY 0
#endif

static int outfd;
static unsigned long cofst;
static unsigned char *bbuf;
static unsigned short xshort;
static unsigned long xlong;
static int idno;
static long bbuflen;

/* SMF structures */

struct mthd {
  char mthd[4];
  unsigned long hdlen;
  short int format;             /* 0 - sgl multichan trk, 1 - 1+ simul, 2 -
                                   * 1+ indep */
  short int ntrks;              /* number of track chunks */
  short int division;           /* time div of a quarter note (or if
                                   * <0, frm/sec,res */
} *hdr;

struct mtrkh {
  unsigned char mtrk[4];
  unsigned long trklen;
  char track[4];
} *mth;

static void writersrc()
{
  write(outfd, bbuf, 4);
  xshort = htons(idno++);
  write(outfd, &xshort, 2);
  xlong = htonl(cofst);
  write(outfd, &xlong, 4);

  xlong = lseek(outfd, 0, SEEK_CUR);
  lseek(outfd, cofst, SEEK_SET);
  write(outfd, &bbuf[8], bbuflen);
  lseek(outfd, xlong, SEEK_SET);
  cofst += bbuflen;
}

int main(int argc, char *argv[])
{
  int fd, i, maxsect;
  char nbuf[32];

  if (argc < 3) {
    fprintf(stderr, "Usage: %s midifile prcfile 'Song Name'\n", argv[0]);
    exit(1);
  }
  if ((fd = open(argv[1], O_BINARY | O_RDONLY)) < 1) {
    fprintf(stderr, "Can't open midi file %s\n", argv[3]);
    exit(-2);
  }
  if (!(bbuf = malloc(65536)))
    exit(-3);

  idno = 0;
  hdr = bbuf;
  read(fd, bbuf, 8);
  bbuflen = htonl(hdr->hdlen);
  read(fd, &bbuf[8], bbuflen);

  if (!(outfd = open(argv[2], O_BINARY | O_WRONLY | O_CREAT | O_TRUNC, 0644)))
    exit(-1);

  memset(nbuf, 0, 32);
  strncpy(nbuf, argv[3], 32);
  write(outfd, nbuf, 32);

  memset(nbuf, 0, 4);
  nbuf[1] = 1;
  nbuf[3] = 1;
  write(outfd, nbuf, 4);

  xlong = time(NULL) + ((66 * 365 + 17) * 24 * 3600UL);
  xlong = htonl(xlong);
  write(outfd, &xlong, 4);
  write(outfd, &xlong, 4);
  write(outfd, &xlong, 4);

  memset(nbuf, 0, 12);
  write(outfd, nbuf, 12);

  write(outfd, "DATA", 4);
  write(outfd, "MIDI", 4);
  nbuf[0] = 0x28;
  write(outfd, nbuf, 8);

  maxsect = htons(hdr->ntrks) + 1;
  xshort = htons(maxsect);
  write(outfd, &xshort, 2);

  cofst = 80 + 10 * maxsect;

  bbuflen = htonl(hdr->hdlen);
  writersrc();

  mth = bbuf;
  for (i = 1; i < maxsect; i++) {
    read(fd, bbuf, 8);
    bbuflen = htonl(mth->trklen);
    fprintf(stderr, "Track:%-2d, len:%lu\n", i, bbuflen);
    if (bbuflen > 65528) {
      fprintf(stderr, "Track too long\n");
      exit(-1);
    }
    read(fd, &bbuf[8], bbuflen);
    writersrc();
  }
  xshort = 0;
  write(outfd, &xshort, 2);

  return 0;
}
